"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const BrowserType_1 = require("./BrowserType");
class Browser {
    static current() {
        if (this._currentType) {
            return this._currentType;
        }
        this._currentType = this.check();
        return this._currentType;
    }
    static check() {
        const userAgent = navigator.userAgent;
        if (userAgent.indexOf('Chrome') > -1) {
            return BrowserType_1.BrowserType.Chrome;
        }
        else if (userAgent.indexOf('Safari') > -1) {
            return BrowserType_1.BrowserType.Safari;
        }
        else if (userAgent.indexOf('Firefox') > -1) {
            return BrowserType_1.BrowserType.Firefox;
        }
        else if (userAgent.indexOf('MSIE') > -1 || userAgent.indexOf('Trident/') > -1) {
            return BrowserType_1.BrowserType.IE;
        }
        else if (userAgent.indexOf('Edge') > -1) {
            return BrowserType_1.BrowserType.Edge;
        }
        else if (userAgent.indexOf('Opera') > -1 || userAgent.indexOf('OPR/') > -1) {
            return BrowserType_1.BrowserType.Opera;
        }
        else {
            return BrowserType_1.BrowserType.Unknown;
        }
    }
}
exports.default = Browser;
Browser._currentType = null;
