"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IndexMovement = void 0;
class IndexMovement {
    constructor(from, to) {
        this.from = from;
        this.to = to;
    }
    reverse() {
        return new IndexMovement(this.to, this.from);
    }
    data() {
        return [this.from, this.to];
    }
    static dataOf(movements) {
        return movements.flatMap(x => x.data());
    }
    static fromData(data) {
        let result = [];
        for (let i = 0; i < data.length; i += 2) {
            result.push(new IndexMovement(data[i], data[i + 1]));
        }
        return result;
    }
    static forMoving(indices, to) {
        let indexMovements = [];
        // Sort the forMoving array in ascending order to ensure proper movements
        let sortedForMoving = indices.slice().sort((a, b) => a - b);
        let target = to;
        for (let from of sortedForMoving) {
            // Create a new IndexMovement instance with the 'from' and 'to' indices
            let movement = new IndexMovement(from, target);
            // Add the movement to the indexMovements array
            indexMovements.push(movement);
            // Increment the target index for the next movement
            target++;
        }
        return indexMovements;
    }
}
exports.IndexMovement = IndexMovement;
