
export class IndexMovement {
    
    from: number
    
    to: number
    
    constructor(from: number, to: number) {
        this.from = from
        this.to = to
    }

    reverse(): IndexMovement {
        return new IndexMovement(this.to, this.from);
    }
    
    data() : number[] {
        return [this.from, this.to]
    }
    
    static dataOf(movements: IndexMovement[]) : number[] {
        return movements.flatMap(x => x.data())
    }
    
    static fromData(data: number[]) : IndexMovement[] {
        let result: IndexMovement[] = []
        for (let i = 0; i < data.length; i += 2) {
            result.push(new IndexMovement(data[i], data[i + 1]))
        }
        return result
    }
    
    static forMoving(indices: number[], to: number) : IndexMovement[] {
        let indexMovements: IndexMovement[] = [];

        // Sort the forMoving array in ascending order to ensure proper movements
        let sortedForMoving = indices.slice().sort((a, b) => a - b);

        let target = to;
        for (let from of sortedForMoving) {
            // Create a new IndexMovement instance with the 'from' and 'to' indices
            let movement = new IndexMovement(from, target);

            // Add the movement to the indexMovements array
            indexMovements.push(movement);

            // Increment the target index for the next movement
            target++;
        }

        return indexMovements;
    }
    
}